#ifndef _h_resultset__
#define _h_resultset__

#include <windows.h>
#include "tp_stub.h"
#include "sqlite3/sqlite3.h"

/**
 * DB ʃZbg
 */
class ResultSet {
	
protected:
	sqlite3 *db;
	sqlite3_stmt *stmt;
	int posCount;

public:
	bool open(const wchar_t *sql);
	bool next();
	void reset();
	void close();

	// SQLG[R[h̎擾
	int getErrorCode();
	// SQLG[bZ[W̎擾
	const wchar_t *getErrorMessage();
	// J̎擾
	int getColumnNoFromName(const wchar_t *name);

	/// oCh
	void bind(tTJSVariant &variant, int pos=0);
	
	// ʂ̐
	int getCount();

	// ----------------------------
	// f[^擾
	bool isNull(int num);
	int getType(int num);
	tTJSVariant *get(int num);
	void get(tTJSVariant *result, int num=0, tTJSVariant *defaultVariant=NULL);
	inline void get(tTJSVariant *result, const wchar_t *name, tTJSVariant *defaultVariant=NULL) {
		get(result, getColumnNoFromName(name), defaultVariant);
	}
	
public:
	ResultSet(sqlite3 *db, const wchar_t *sql = NULL) : db(db) {stmt = NULL; if (sql) open(sql);}

	~ResultSet() {
		close();
	}
};

#endif
